vsg: vsg::RecordTraversal Class Reference

vsg 1.1.13 VulkanSceneGraph library

Loading...
Searching...
No Matches
vsg::RecordTraversal Class Reference

RecordTraversal traverses a scene graph doing view frustum culling and invoking state/commands to record them to a Vulkan command buffer. More...

`#include <RecordTraversal.h>`

Inheritance diagram for vsg::RecordTraversal:
[legend]
Collaboration diagram for vsg::RecordTraversal:
[legend]

## Public Member Functions
| RecordTraversal (const Slots &in_maxSlots={}, const std::set< Bin * > &in_bins={})
| RecordTraversal (const RecordTraversal &)=delete
RecordTraversal & | operator= (const RecordTraversal &rhs)=delete
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
State * | getState ()
| get the current State object used to track state and projection/modelview matrices for the current subgraph being traversed
CommandBuffer * | getCommandBuffer ()
| get the current CommandBuffer for the current subgraph being traversed
uint32_t | deviceID () const
| get the current DeviceID for the current subgraph being traversed
void | setFrameStamp (FrameStamp *fs)
FrameStamp * | getFrameStamp ()
void | setDatabasePager (DatabasePager *dp)
DatabasePager * | getDatabasePager ()
void | apply (const Object &object)
void | apply (const Group &group)
void | apply (const QuadGroup &quadGroup)
void | apply (const LOD &lod)
void | apply (const PagedLOD &pagedLOD)
void | apply (const TileDatabase &tileDatabase)
void | apply (const CullGroup &cullGroup)
void | apply (const CullNode &cullNode)
void | apply (const DepthSorted &depthSorted)
void | apply (const Layer &layer)
void | apply (const Switch &sw)
void | apply (const RegionOfInterest &roi)
void | apply (const VertexDraw &vid)
void | apply (const VertexIndexDraw &vid)
void | apply (const Geometry &vid)
void | apply (const Light &light)
void | apply (const AmbientLight &light)
void | apply (const DirectionalLight &light)
void | apply (const PointLight &light)
void | apply (const SpotLight &light)
void | apply (const Transform &transform)
void | apply (const MatrixTransform &mt)
void | apply (const CoordinateFrame &cf)
void | apply (const Joint &joint)
void | apply (const InstanceNode &instanceNode)
void | apply (const InstanceDraw &instanceDraw)
void | apply (const InstanceDrawIndexed &instanceDrawIndexed)
void | apply (const StateGroup &object)
void | apply (const Commands &commands)
void | apply (const Command &command)
void | apply (const Bin &bin)
void | apply (const View &view)
void | apply (const CommandGraph &commandGraph)
void | addToBin (int32_t binNumber, double value, const Node *node)
void | clearBins ()
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
virtual const std::type_info & | type_info () const noexcept
| return the std::type_info of this Object
virtual bool | is_compatible (const std::type_info &type) const noexcept
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual int | compare (const Object &rhs) const
| compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,
virtual void | accept (Visitor &visitor)
virtual void | traverse (Visitor &)
virtual void | accept (ConstVisitor &visitor) const
virtual void | traverse (ConstVisitor &) const
virtual void | accept (RecordTraversal &visitor) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Static Public Member Functions
template<typename... Args>
static ref_ptr< RecordTraversal > | create (Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Public Attributes
Mask | traversalMask = MASK_ALL
Mask | overrideMask = MASK_OFF
float | intensityMinimum = 0.001f
| Light::intensity minimum value for a light to be passed to GPU.
ref_ptr< Instrumentation > | instrumentation
ref_ptr< RecordedCommandBuffers > | recordedCommandBuffers
| Container for CommandBuffers that have been recorded in current frame.
std::vector< std::pair< dmat4, const RegionOfInterest * > > | regionsOfInterest
ref_ptr< FrameStamp > | frameStamp
ref_ptr< State > | state
ref_ptr< DatabasePager > | databasePager
ref_ptr< CulledPagedLODs > | culledPagedLODs
int32_t | minimumBinNumber = 0
std::vector< ref_ptr< Bin > > | bins
ref_ptr< ViewDependentState > | viewDependentState

## Additional Inherited Members
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

RecordTraversal traverses a scene graph doing view frustum culling and invoking state/commands to record them to a Vulkan command buffer.

## Member Function Documentation

## ◆ className()

const char * vsg::RecordTraversal::className | ( |  | ) | const
| inlineoverridevirtualnoexcept

Reimplemented from vsg::Object.

## ◆ sizeofObject()

std::size_t vsg::RecordTraversal::sizeofObject | ( |  | ) | const
| inlineoverridevirtualnoexcept

Reimplemented from vsg::Object.

The documentation for this class was generated from the following file:

- include/vsg/app/RecordTraversal.h